function f(str){
  for(i = 1; i < arguments.length; i++){
    str = str.replace('[' + (i - 1) + ']', arguments[i]);
  }
  
  return str;
}

function loadPage(url){
	document.location = url;
}

function $id(id){
  return $(f("#[0]", id));
}

var $tabsLinks = null;
var $tabsPanels = null;
var tabsIDs = null;
var $outrigger = null;
var defaultTab = null;



function loadTabsLogic(defaultTabArg){
	$tabsLinks = $(".ui-tabs .ui-tabs-nav LI");
	$tabsPanels = $(".ui-tabs-panel");
	
	var onShowFunc = function(a,b,c){};
	if(arguments.length > 1){
		onShowFunc =arguments[1]; 
	}
	
	$("#searchContent").tabs({
		initial: defaultTabArg,
		containerClass: "ui-tabs",
		hideClass: "ui-tabs-hide",
		navClass: "ui-tabs-nav",
		tabStruct:"#outrigger div.ui-tabs-panel",
		selectedClass:"current",
		onShow:onShowFunc
	});
	
	
	$(".ui-tabs-nav a").bind("click", function(){
		var currHref = $(this).attr("href");
		
		$(".ui-tabs-nav LI")
			.removeClass("current")
			.find( f("a[href=[0]]", currHref) )
			.parents("LI")
			.addClass("current");
		
		//window.scrollTo(0,0);
	});
	
	var initHref = $("#searchMenu .ui-tabs-nav li.current a").attr("href");
	
	$(".ui-tabs-nav LI")
		.removeClass("current")
		.find( f("a[href=[0]]", initHref) )
		.parents("LI")
		.addClass("current");
	
	
	
}

var currentAnchor = null;

function showTab(tab){
  tab = "tab_" + tab;
  $tabsPanels.filter(":visible").hide();
  $id(tab).show();
    

  $tabsLinks.removeAttr("id").find("A").removeClass("current");
  
  $tabsLinks.filter(f("#searchMenu .[0]", tab)).attr("id","tmOn");
  $tabsLinks.filter(f("#searchMenuBtm .[0]", tab)).attr("id","bmOn");
  
  $tabsLinks.filter(f(".[0]", tab)).find("A").addClass("current");
}


function downloadPdf($form, downloadAction){
	var defaultAction = $form.attr("action");
	
	$forDownload = $form.find("INPUT[name=asAttachment]");
	$forPrint = $form.find("INPUT[name=forPrint]");
	
	
	var defaultDownload = $forDownload.val();
	var defaultPrint = $forPrint.val();
	
	$form.attr("target", "downloadPdfIframeId");
	changeAction($form, downloadAction);
	
	$forDownload.val("true");
	$forPrint.val("false");
	
	$form.submit();
	
	//Set settings back
	if($form.attr("target") !== ""){
		$form.attr("target", "");
	}
	if($form.attr("action") !== defaultAction){
		changeAction($form, defaultAction);
	}
	
	$forDownload.val(defaultDownload);
	$forPrint.val(defaultPrint);
}


function printPdf(formId, downloadAction){
	var $form = $id(formId);
	var defaultAction = $form.attr("action");
	
	$forDownload = $form.find("INPUT[name=asAttachment]");
	$forPrint = $form.find("INPUT[name=forPrint]");
	
	var defaultDownload = $forDownload.val();
	var defaultPrint = $forPrint.val();
	
	$form.attr("target", "printPdfIframeId");
	changeAction($form, downloadAction);
	
	$forPrint.val("true");
	$forDownload.val("false");
	
	$form.submit();
	
	//Set settings back
	if($form.attr("target") !== ""){
		$form.attr("target", "");
	}
	if($form.attr("action") !== defaultAction){
		changeAction($form, defaultAction);
	}
	
	$forDownload.val(defaultDownload);
	$forPrint.val(defaultPrint);
}

function printSelected(formObj, checkBoxName, downloadAction) {
	var n = $(f("INPUT:checked[name=[0]]", checkBoxName)).length;
	if(n > 0) {
		printPdf(formObj, downloadAction);
	} else {
		alert("Please select page(s) to be printed.");
	}
}

function changeAction($obj, newAction){
	changeAttribute($obj, "action", newAction);
}

function changeAttribute($obj, attribute, newValue){
	$obj[0].attributes[attribute].value = newValue; 
}

function undockedPopUp(mylink, windowname){
	while(windowname.indexOf(" ")!= -1){
		windowname = windowname.replace(" ","_");
	}
	
	var rnd = getRandomInt(0,42000);
	var wname = f("[0]_[1]",windowname,rnd);
	//var params = getNewWindowCenterString(800, 900) + ', scrollbars=yes';
	var params = getNewWindowCenterStringForUndockedView(800, 900) + ', scrollbars=yes';
	
	var fixed = wname.replace(/[^a-zA-Z0-9]+/g,'_'); //remvoe special characters
	var w = window.open(mylink, fixed, params);
}

function getRandomInt(min, max){
  return Math.floor(Math.random() * (max - min + 1)) + min;
}

function loadUndockedPopup(isPdfExist, pdfLink, pageId, includeCoverPrimaryKey, isCoverExist) {
	if(isPdfExist == 'false') {
		alert("PDF document not found - please try again.\nIf error continues - contact your Administrator");
		return;
	} 
		
	if(includeCoverPrimaryKey != ""){
		if(isCoverExist == 'false') {
			alert("Cover not available");
		} else {
			pdfLink += "&includeCover=" + includeCoverPrimaryKey;
		}
	}
	
	pdfLink += "#view=Fit&toolbar=1";
	
	undockedPopUp(pdfLink, pageId);
}


var $formForSubmit;
var windowToLook;
function fireProgress($form, win){
	iamloaded = false;
	var w = window.open(progressLink, "progressWindow", getNewWindowCenterString(300, 200) + ',scrollbars=no,toolbar=no,menu=no,sizable=no');
	$formForSubmit = $form;
	windowToLook = win;
}

function getNewWindowCenterString(width, height){
	var str = f("width=[0], height=[1], left=[2], top=[3]", 
			width, height, getPopUpLeft(width), getPopUpTop(height));
	return str;
}

//o.shilov - new copy not to break the existing code
function getNewWindowCenterStringForUndockedView(width, height){
	var str = f("width=[0], height=[1], left=[2], top=[3]", 
			width, height, getPopUpLeft(width), getPopUpTopForUndockedView(height));
	return str;
}


function getPopUpTop(popUpHeight){
	var winY = window.screenY || window.screenTop; 
	var winHeight = $(window).height();
	//var popHeight = popUp.outerHeight;
	var popScreenY = winY + winHeight/2 - popUpHeight/2;
	
	return popScreenY;
}

function getPopUpTopForUndockedView(popUpHeight){
	//var winY = window.screenY || window.screenTop; 
	//var winHeight = $(window).height();
	
	//var popScreenY = winY + winHeight/2 - popUpHeight/2;
	
	var popScreenY = 0;
	
	return popScreenY;
}

function getPopUpLeft(popUpWidth){
	var winX = window.screenX || window.screenLeft;
	var winWidth = $(window).width();
	//var popWidth = popUp.outerWidth;
	var popScreenX = winX + winWidth/2 - popUpWidth/2;
	return popScreenX;
}

function centerPopUp(popUp){	
	var popScreenY = getPopUpTop(popUp.outerHeight);
	var popScreenX = getPopUpLeft(popUp.outerWidth);
	
	popUp.screenX = popScreenX;
	popUp.screenY = popScreenY;
}

function setCookie(name, value, exp_y, exp_m, exp_d, path, domain, secure){
  var cookie_string = name + "=" + escape(value);

  if (exp_y){
    var expires = new Date(exp_y, exp_m, exp_d);
    cookie_string += "; expires=" + expires.toGMTString();
  }

  if (path){
        cookie_string += "; path=" + escape(path);
  }

  if (domain){
        cookie_string += "; domain=" + escape(domain);
  }
  
  if (secure){
        cookie_string += "; secure";
  }
  
  document.cookie = cookie_string;
}

function getCookie(cookie_name){
  var results = document.cookie.match('(^|;) ?' + cookie_name + '=([^;]*)(;|$)');

  if (results){
    return (unescape(results[2]));
  }else{
    return null;
  }
}

function deleteCookie(cookie_name){
  var cookie_date = new Date ();  // current date & time
  cookie_date.setTime(cookie_date.getTime() - 1);
  document.cookie = cookie_name += "=; expires=" + cookie_date.toGMTString();
}


function downloadSelected(popUpHref, formId) {
	var n = $("INPUT:checked[name!=includeCover]").length;

//	if(n > 0) {
		var headingWindows = window.open("", "headingWindows", getNewWindowCenterString(370, 145));
		var $form = $id(formId);
		var defaultAction = $form.attr("action");
		
		changeAction($form, popUpHref);
		changeAttribute($form,'target', "headingWindows");
		
		$form.submit();
	
		changeAction($form, defaultAction);
		changeAttribute($form,'target', "_self");
		
/*	} else {
		alert("Please select page(s) to be downloaded.");
	} */
}

function getCoverPrimary(id1, id2){
	var $checkBox = $id(f("includeCoverId_[0]_[1]",id1,id2));
	if($checkBox.is(":checked")){
		return $checkBox.val();
	}else{
		return "";
	}
}

var usernameCookie = "username";
var passwordCookie = "password";

function getCookiesLogin(usernameId, passwordId, rememberMeId){
	var userName = getCookie(usernameCookie);
	var password = getCookie(passwordCookie);
	
	if(userName == null && password == null){
		$id(rememberMeId).removeAttr("checked");
	}else{
	
		/*
		* O.Shilov
		* Bug fix for bug #228. When one of 2 fields is empty, it is set to 'null' text.
		*/
		if (userName == null) {
			userName = "";
		}
		
		if (password == null) {
			password = "";
		}
		
	
		$id(rememberMeId).attr("checked", "checked");
		$id(usernameId).val(userName);
		$id(passwordId).val(password);
	}
}

function scrollToSelected($select){
	//Get last selected Item deselect it and again select.
	//Scrolls in browsers down to it.
	var selectIndex = -1; //$select[0].selectedIndex;
	$select.find("option").each(function(i){
		if($(this).is(":selected")){
			selectIndex = i;
		}
	});
	
	if(selectIndex >= 0){
		var opt = $select[0].options[selectIndex];
		opt.selected = false;
		opt.selected = true;
	}		
}

function signInForm(formId){
	var userName = $id("usernameId").val();
	var password = $id("passwordId").val();
	var rememberMe = $("#rememberMeId:checked").length != 0;
	
	if(rememberMe){
		setCookie(usernameCookie, userName, 2042,12,12, "/");
		setCookie(passwordCookie, password, 2042,12,12, "/");
	}else{
		setCookie(usernameCookie, "", 1983,12,20, "/");
		setCookie(passwordCookie, "", 1983,12,20, "/");
	}
	
	$id(formId).submit();	
}

function copyAllFormData($from, $to){
	
	function getHidden(name, value){
		return f("<input value='[0]' type='hidden' name='[1]' />", 
				value, name);
	}
	
	$("INPUT[type=hidden]", $to).remove();
	
	var $inputs = $(
		"INPUT[type=text], INPUT[type=hidden], " +
		"INPUT[type=radio]:checked, INPUT[type=checkbox]:checked, " +
		"TEXTAREA", $from);
	var $selects = $("SELECT", $from);
	
	$inputs.each(function(){
		$to.append(getHidden($(this).attr("name"), $(this).val()));
	});
	
	$selects.each(function(){
		var selName = $(this).attr("name");
		$("OPTION:selected", $(this)).each(function(){
			$to.append(f(getHidden(selName, $(this).val())));
		});
	});
}

function getIndexOf(array, input){
	for(var i=0; i < array.length; i++){
		if(array[i] === input){
			return i;
		}
	}
	return -1;
}

$(function(){
	
	var numericFilter = function(e){
		var val = $(this).val();
		var ok = true;
		while (/[^0-9]/.test(val)){
			val = val.replace(/[^0-9]/,"");
			ok = false;
		}
		
		if(!ok){
			$(this).val(val);
		}
	};
	
	$(".numeric")
		.keyup(numericFilter)
		.change(numericFilter)
		.keypress(function(e){
			
			var code = e.charCode
			if(code == undefined){ //For IE
				code = e.keyCode;
			}
			
			if(e.ctrlKey || (code >= 48 && code <= 57) || code == 0){
				return true;
			}else{
				return false
			}
		})
		.bind('paste', function(e){
			window.setTimeout(function(){$(".numeric").trigger("change")}, 100);
		});
	
	$("select").change(function(e){
		$(this).find("option.disabled").removeAttr("selected");
	});
	
	$(":radio").keydown(function(e){
		var code = e.keyCode;
		var $t = $(this);
		if(code == 9){
			var tiStr = $t.attr("tabindex");
			if(tiStr == "") {
				return true;
			}
			var ti = new Number(tiStr);
			var $nextToFocus = $(f(":radio[tabindex=[0]]",ti+1));
			
			if($nextToFocus.length != 0){
				$nextToFocus.focus();
				return false;
			}
		}
	});
});

if (!document.ELEMENT_NODE) {
  document.ELEMENT_NODE = 1;
  document.ATTRIBUTE_NODE = 2;
  document.TEXT_NODE = 3;
  document.CDATA_SECTION_NODE = 4;
  document.ENTITY_REFERENCE_NODE = 5;
  document.ENTITY_NODE = 6;
  document.PROCESSING_INSTRUCTION_NODE = 7;
  document.COMMENT_NODE = 8;
  document.DOCUMENT_NODE = 9;
  document.DOCUMENT_TYPE_NODE = 10;
  document.DOCUMENT_FRAGMENT_NODE = 11;
  document.NOTATION_NODE = 12;
}

	document._importNode = function(doc, node, allChildren) {
	  switch (node.nodeType) {
	    case document.ELEMENT_NODE:
	      var newNode = doc.createElement(node.nodeName);
	      /* does the node have any attributes to add? */
	      if (node.attributes && node.attributes.length > 0)
	        for (var i = 0; il = node.attributes.length; i < il)
	          newNode.setAttribute(node.attributes[i].nodeName, node.getAttribute(node.attributes[i++].nodeName));
	      /* are we going after children too, and does the node have any? */
	      if (allChildren && node.childNodes && node.childNodes.length > 0)
	        for (var i = 0; il = node.childNodes.length; i < il)
	          newNode.appendChild(doc._importNode(doc, node.childNodes[i++], allChildren));
	      return newNode;
	      break;
	    case document.TEXT_NODE:
	    case document.CDATA_SECTION_NODE:
	    case document.COMMENT_NODE:
	      return doc.createTextNode(node.nodeValue);
	      break;
	  }
	};